﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Common;
using System.Runtime.Serialization;

namespace HeuristicLab.Services.Hive.Common.DataTransfer {
  [DataContract]
  [Serializable]
  public class HiveItemBase : IDeepCloneable {
    public virtual IDeepCloneable Clone(Cloner cloner) {
      HiveItem clone = (HiveItem)Activator.CreateInstance(this.GetType(), true);
      cloner.RegisterClonedObject(this, clone);
      return clone;
    }

    public object Clone() {
      return Clone(new Cloner());
    }
  }
}
